from unittest import result
from flask import Flask, render_template, request
from sqlalchemy.exc import SQLAlchemyError
from sqlalchemy import create_engine

app = Flask(__name__)

@app.route("/")
def index():

    dialect = "mysql"
    username = "root"
    psw = ""
    host="127.0.0.1"
    dbname = "Artworks"

    engine = create_engine(f"{dialect}://{username}:{psw}@{host}/{dbname}")
    
    try:
        con = engine.connect()
        query = "SELECT DISTINCT city FROM Artwork"
        result = con.execute(query)
        con.close()
        return render_template("index.html", rows=result)
    except SQLAlchemyError as e:
        error = str(e.__dict__['orig'])
        return render_template('error.html', error_message=error)


@app.route("/artworks", methods=["GET", "POST"])
def art_req():

    error = ""
    if not('yearFrom' in request.args and 'yearTo' in request.args):
        error += 'Insert starting and ending year. '
        
    elif not(request.args.get('yearFrom').isdigit() and request.args.get('yearTo').isdigit()):
        error += 'Year not valid, please insert a valid numerical value. '
    elif int(request.args.get('yearFrom')) > int(request.args.get('yearTo')):
        error += 'The ending year cannot precede the starting year. '
    if not('city' in request.args) or request.args.get('city')=="":
        error += 'Insert city. '

    if error:
        return render_template('error.html', error_message=error)

    dialect = "mysql"
    username = "root"
    psw = ""
    host="127.0.0.1"
    dbname = "Artworks"

    try:
        engine = create_engine(f"{dialect}://{username}:{psw}@{host}/{dbname}")
        con = engine.connect()
    except SQLAlchemyError as e:
        error = str(e.__dict__['orig'])
        return render_template('error.html', error_message=error)

    if request.method == "GET":
        yearFrom = request.args.get("yearFrom")
        yearTo = request.args.get("yearTo")
        city = request.args.get("city")
    else:
        yearFrom = request.form["yearFrom"]
        yearTo = request.form["yearTo"]
        city = request.form["city"]

    query = f"SELECT A.surname, W.name, W.category FROM Author A, Artwork W WHERE A.codA = W.author and year < {int(yearTo)+1} and year > {int(yearFrom)-1} and W.city = '{city}'"

    result = con.execute(query)
    header = result.keys()

    return render_template("art.html", header=header, values=result, yearFrom=yearFrom, yearTo=yearTo, city=city)

app.run(debug=True, port=5001)